
if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='usuarios'   
                  and c.name='fechaAlta')  
  ALTER TABLE usuarios add fechaAlta datetime null 
go

Update usuarios 
set fechaAlta = '19000101'
where fechaalta is null
go

/**************************************************************************************************
 * Name          : InsertaBitacora2
 * Project       : Usuarios
 * Description   : inserta en la bitacora el movimiento               
 * Table name    : bitacora
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : miercoles,21 de dicimebre de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'InsertaBitacora2'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.InsertaBitacora2
GO

create PROCEDURE dbo.InsertaBitacora2
	@empresa VARCHAR(2) ,
	@hora VARCHAR(20) ,
	@funcion VARCHAR(20) ,
	@codigo bigint ,
	@opcion VARCHAR(20),
	@opcion2 VARCHAR(20),
	@opcion3 VARCHAR(20),
	@usuario VARCHAR(20),
	@clave VARCHAR(20),
	@registroPatronal VARCHAR(20),
	@sistema varchar(2)

AS
SET NOCOUNT ON
SET DATEFORMAT MDY

Insert into bitacora ( empresa
					   ,fecha
					   ,hora
					   ,funcion
					   ,codigo
					   ,opcion
					   ,opcion2
					   ,opcion3
					   ,usuario
					   ,clave
					   ,regpat
					   ,sistema)
values (
		@empresa ,
		GETDATE(),
		@hora ,
		@funcion,
		@codigo,
		@opcion,
		@opcion2,
		@opcion3,
		@usuario,
		@clave,
		@registroPatronal,
		@sistema)

GO

/**************************************************************************************************
 * Name          : LlenaIndicacionesUsuarios
 * Project       : Usuarios
 * Description   : obtiene la lista de los usuarios                 
 * Table name    : usuarios
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'LlenaIndicacionesUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.LlenaIndicacionesUsuarios
GO

CREATE PROCEDURE [dbo].LlenaIndicacionesUsuarios
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	SELECT Longitud_password,Requiere_numeros 
	FROM ctrl_usuarios
		
GO

/**************************************************************************************************
 * Name          : configuracionUsuarios
 * Project       : Usuarios
 * Description   : obtiene la lista de los usuarios                 
 * Table name    : ctrl_usuarios
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'configuracionUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.configuracionUsuarios
GO

CREATE PROCEDURE [dbo].configuracionUsuarios
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	SELECT Dias_vigencia
		  ,Longitud_password
		  ,Rotacion_password
		  ,Requiere_numeros
		  ,Dias_aviso
	FROM ctrl_usuarios
		
GO


/**************************************************************************************************
 * Name          : actualizaConfiguracionUsuarios
 * Project       : Usuarios
 * Description   : actualiza la Configuracion de Usuarios                 
 * Table name    : ctrl_usuarios
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'actualizaConfiguracionUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.actualizaConfiguracionUsuarios
GO

CREATE PROCEDURE [dbo].actualizaConfiguracionUsuarios
	(@DiasVigencia bigint,
	@longitud bigint,
	@rotacion bigint,
	@numerosRequeridos bigint,
	@diasAviso bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	UPDATE Ctrl_usuarios
	SET Dias_vigencia = @DiasVigencia
	  ,Longitud_password = @longitud
	  ,Rotacion_password = @rotacion
	  ,Requiere_numeros = @numerosRequeridos
	  ,Dias_aviso = @diasAviso
		
GO



/**************************************************************************************************
 * Name          : CargarEmpresas
 * Project       : Usuarios
 * Description   : carga los sistemas apsi             
 * Table name    : sistemas
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarEmpresas
GO

CREATE PROCEDURE [dbo].CargarEmpresas
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	select empresa,nombre_empresa
	from empresas
GO

/**************************************************************************************************
 * Name          : CargarSistemas
 * Project       : Usuarios
 * Description   : carga los sistemas apsi             
 * Table name    : sistemas
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarSistemas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarSistemas
GO

CREATE PROCEDURE [dbo].CargarSistemas
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	select sistema, nombre
	from Sistema
GO

/**************************************************************************************************
 * Name          : CargarFunciones
 * Project       : Usuarios
 * Description   : carga las funciones de un sistema              
 * Table name    : funciones
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarFunciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarFunciones
GO

CREATE PROCEDURE [dbo].CargarFunciones
	(@sistema varchar(3))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	if @sistema='TODOS'
		Select fUNCION 	from FUNCIONES 
	else
		Select fUNCION 	from FUNCIONES 	WHERE SISTEMA=@sistema
GO

/**************************************************************************************************
 * Name          : CargarPerfiles
 * Project       : Usuarios
 * Description   : obtiene la lista de los perfiles                
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarPerfiles
GO

CREATE PROCEDURE [dbo].CargarPerfiles
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    Select p.idPerfil, p.Descripcion, s.nombre, p.actualizar, p.sueldo  
    from perfiles p, sistema s
    where p.sistema=s.sistema
		
GO
/**************************************************************************************************
 * Name          : ValidaPerfilEnUSuario
 * Project       : Usuarios
 * Description   : obtiene la lista de los perfiles                
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ValidaPerfilEnUSuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ValidaPerfilEnUSuario
GO

CREATE PROCEDURE [dbo].ValidaPerfilEnUSuario
	(@idPerfil bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	delete from perfil_funcion where idPerfil=@idPerfil
    delete from perfil_centro where idPerfil=@idPerfil
    delete from perfiles where idPerfil=@idPerfil
		
GO

/**************************************************************************************************
 * Name          : eliminarPerfil
 * Project       : Usuarios
 * Description   : obtiene la lista de los perfiles                
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'eliminarPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.eliminarPerfil
GO

CREATE PROCEDURE [dbo].eliminarPerfil
	(@idPerfil bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	delete from perfil_funcion where idPerfil=@idPerfil
    delete from perfil_centro where idPerfil=@idPerfil
    delete from perfiles where idPerfil=@idPerfil
		
GO
            
/**************************************************************************************************
 * Name          : CargarPerfilesDeUsuario
 * Project       : Usuarios
 * Description   : obtiene la lista de los perfiles del usuario                
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarPerfilesDeUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarPerfilesDeUsuario
GO

CREATE PROCEDURE [dbo].CargarPerfilesDeUsuario
	(@usuario as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	Select s.nombre, pu.idPerfil, p.Descripcion  
    from perfil_usuarios pu, perfiles p, sistema s
    where pu.idperfil=p.idperfil 
    and p.sistema=s.sistema
    and pu.usuario=@usuario
		
GO            

            
/**************************************************************************************************
 * Name          : AsignarPerfilUsuario
 * Project       : Usuarios
 * Description   : asigna un perfil a un usuario                
 * Table name    : perfiles, usuarios, perfil_usuario
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 27 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'AsignarPerfilUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.AsignarPerfilUsuario
GO

CREATE PROCEDURE [dbo].AsignarPerfilUsuario
	(@usuario as varchar(50),
	@idperfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	Insert into perfil_usuarios (idPerfil, usuario) 
	values (@idperfil,@usuario )
		
GO  

/**************************************************************************************************
 * Name          : obtenClaveSistema
 * Project       : Usuarios
 * Description   : obtiene la clave del sistema                 
 * Table name    : sistema
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 28 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenClaveSistema'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenClaveSistema
GO

CREATE PROCEDURE [dbo].obtenClaveSistema
	(@nombre as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	Select sistema 
	from sistema 
	where nombre=@nombre
		
GO

/**************************************************************************************************
 * Name          : obtenNombreSistema
 * Project       : Usuarios
 * Description   : obtiene el nombre del sistema                 
 * Table name    : sistema
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 28 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenNombreSistema'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenNombreSistema
GO

CREATE PROCEDURE [dbo].obtenNombreSistema
	(@sistema as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	if @sistema='0'
		Select Nombre from sistema
	else
		Select Nombre from sistema where sistema=@sistema
	
		
GO

/**************************************************************************************************
 * Name          : obtenEmpresasSegunPerfil
 * Project       : Usuarios
 * Description   : obtiene las empresas segun el perfil                 
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 28 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenEmpresasSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenEmpresasSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenEmpresasSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    declare @lista varchar(300)
	
	Select @lista = empresas
	from perfiles 
	where idPerfil=@idPerfil
	
	if len(@lista)>2
		begin
			set @lista = SUBSTRING(@lista,2,len(@lista)-2)

			select empresa 
			from empresas
			where empresa in (@lista)
		end	
	else
		select 0 from empresas		

GO                         

/**************************************************************************************************
 * Name          : obtenNominaSegunPerfil
 * Project       : Usuarios
 * Description   : obtiene los tipos de nomina segun el perfil                 
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : MARTES, 28 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenNominaSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenNominaSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenNominaSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    declare @lista varchar(300)
	
	Select @lista = nomina
	from perfiles 
	where idPerfil=@idPerfil
	
	if len(@lista)>2
		begin
			set @lista = SUBSTRING(@lista,2,len(@lista)-2)

			select distinct(tiponom), nomina 
			from nominas 			
			where tiponom in (@lista)			
		end	
	else
		select 0 from empresas		

GO                         

/**************************************************************************************************
 * Name          : obtenReportesSegunPerfil
 * Project       : Usuarios
 * Description   : obtiene los tipos de nomina segun el perfil                 
 * Table name    : perfil_reporte
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : miercoles, 28 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenReportesSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenReportesSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenReportesSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	Select reporte, empresa 
	from perfil_reporte 
	where idPerfil=@idPerfil

GO  

/**************************************************************************************************
 * Name          : obtenCentrosSegunPerfil
 * Project       : Usuarios
 * Description   : obtiene los tipos de nomina segun el perfil                 
 * Table name    : perfil_centros
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : miercoles, 28 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenCentrosSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenCentrosSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenCentrosSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	Select isnull(centro,'')
	from perfil_centro
	where idPerfil=@idPerfil

GO

/**************************************************************************************************
 * Name          : borraOpcionesFuncion
 * Project       : Usuarios
 * Description   : borra las opciones y funciones                 
 * Table name    : funcion
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'borraOpcionesFuncion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.borraOpcionesFuncion
GO

CREATE PROCEDURE [dbo].borraOpcionesFuncion
	(@funcion as varchar(10),
	 @idperfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	delete from perfil_funcion where 
    funcion = @funcion
    and idPerfil=@idperfil

GO

/**************************************************************************************************
 * Name          : reportePerfilesDeUsuario
 * Project       : Usuarios
 * Description   : reporte Perfiles De Usuario                 
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reportePerfilesDeUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reportePerfilesDeUsuario
GO

CREATE PROCEDURE [dbo].reportePerfilesDeUsuario
	(@usuario as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)
    declare @groupByClause as varchar(1024)

    
	set @selectClause = ' SELECT
							usuarios.usuario ,
							usuarios.descripcion as nombreUsuario,
							perfiles.idperfil,
							perfiles.descripcion as nombrePerfil,
							perfiles.sistema,
							perfiles.actualizar,
							perfiles.sueldo,
							perfil_funcion.funcion,
							FUNCIONES.descripcion AS funcionNombre,
							opciones.opcion,
							opciones.descripcion as opcionNombre'
	set @fromClause = ' FROM usuarios
						left join perfil_usuarios on usuarios.usuario = perfil_usuarios.usuario
						left join perfiles on perfil_usuarios.idperfil=perfiles.idperfil
						left join perfil_funcion on perfiles.idperfil=perfil_funcion.idperfil
						left join funciones on perfiles.sistema=funciones.sistema 
											and perfil_funcion.funcion=funciones.funcion
						left join opciones on perfiles.sistema=opciones.sistema 
											and opciones.funcion=funciones.funcion	
											and opciones.opcion=perfil_funcion.opcion	'
	if @usuario<>'0'
		set @WhereClause = ' WHERE USUARIOS.usuario= ''' + @usuario + ''''
	
	set @groupByClause = ' group BY
							usuarios.usuario ,
							usuarios.descripcion ,
							perfiles.idperfil,
							perfiles.descripcion ,
							perfiles.sistema,
							perfiles.actualizar,
							perfiles.sueldo,
							perfil_funcion.funcion,
							FUNCIONES.descripcion ,
							opciones.opcion,
							opciones.descripcion '
	set @OrderByClause = ' order by 
						usuarios.usuario ,
						perfiles.idperfil,
						perfiles.sistema,
						perfil_funcion.funcion,
						opciones.opcion'
		
	exec (@selectClause + @fromClause + @whereClause + @groupByClause + @OrderByClause)

GO





/**************************************************************************************************
 * Name          : reporteUsuarioExpiracion
 * Project       : Usuarios
 * Description   : reporte usuario Expiracion                 
 * Table name    : usuarios
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteUsuarioExpiracion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteUsuarioExpiracion
GO

CREATE PROCEDURE [dbo].reporteUsuarioExpiracion
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	SELECT usuario,
		    descripcion,
		   convert(varchar(10),expiracion,103) as fecha,
		   convert(varchar(10),fechaCambio,103) as fechacambio,
		    motivoCambio 		
	FROM usuarios
	order by usuario
GO


/**************************************************************************************************
 * Name          : reporteUsuarioAltas
 * Project       : Usuarios
 * Description   : reporte usuario Altas                 
 * Table name    : usuarios
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteUsuarioAltas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteUsuarioAltas
GO

CREATE PROCEDURE dbo.reporteUsuarioAltas
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	SELECT  usuario,
		    descripcion,
		    fechaAlta,
		    fechaCambio,
		    motivoCambio 		
	FROM usuarios
	order by usuario
GO


/**************************************************************************************************
 * Name          : reporteHistoricoDeUsuarios
 * Project       : Usuarios
 * Description   : reporte historico por Usuario                 
 * Table name    : hpwd
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteHistoricoDeUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteHistoricoDeUsuarios
GO

CREATE PROCEDURE [dbo].reporteHistoricoDeUsuarios
	(@usuario as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    if @usuario<>'0'
		begin
			SELECT hpwd.usuario,
			   convert(varchar(10),hpwd.fch_modifico,103) as fecha		
			FROM hpwd
			where usuario=@usuario
		end
	else
		begin
			SELECT hpwd.usuario,
			   convert(varchar(10),hpwd.fch_modifico,103) as fecha		
			FROM hpwd
		end
	

GO

/**************************************************************************************************
 * Name          : reporteBitacoraPorFuncion
 * Project       : Usuarios
 * Description   : reporte bitacora por funcion                 
 * Table name    : bitacora
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteBitacoraPorFuncion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteBitacoraPorFuncion
GO

CREATE PROCEDURE [dbo].reporteBitacoraPorFuncion
	(@idempresa as bigint,
	 @sistema as varchar(5),
	 @funcion as varchar(10),
	 @fechaDe as datetime,
	 @fechaA as datetime)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)  
    
	set @selectClause = ' SELECT
							convert(decimal(9,0),empresas.empresa) as empresa,
							empresas.nombre_empresa,
							convert(varchar(10),bitacora.fecha,103) as fecha,
							bitacora.hora,
							bitacora.funcion,
							funciones.descripcion,
							bitacora.opcion,
							bitacora.opcion2,
							bitacora.opcion3,
							bitacora.usuario,
							BITACORA.CODIGO,
							bitacora.sistema,
							sistema.nombre'
	set @fromClause   = ' FROM
							(empresas empresas LEFT OUTER JOIN bitacora bitacora ON
								empresas.empresa = bitacora.empresa)
							LEFT OUTER JOIN Sistema  ON
								bitacora.sistema = sistema.sistema
							left join funciones on funciones.funcion=bitacora.funcion and funciones.sistema=bitacora.sistema '
						
	set @whereClause  = ' WHERE
						bitacora.fecha >= ''' +  convert(varchar(10),@fechade,112)  + ''' AND
						bitacora.fecha <= ''' +  convert(varchar(10),@fechaA,112) + ''''
	
	if @idempresa<>'0'
		begin
			set @whereClause = @whereClause + ' and empresas.empresa=' + CONVERT(varchar(8),@idempresa)
		end	
		
	if @sistema<>'TODOS'
		begin
			set @whereClause = @whereClause + ' and bitacora.sistema =''' + @sistema + ''''
		end	
		
	if @funcion<>'TODOS'
		begin
			if @sistema='NO' and substring(@funcion,1,1)='X'
				set @whereClause = @whereClause + ' and bitacora.funcion=''X'''
			else
				set @whereClause = @whereClause + ' and bitacora.funcion=''' + @funcion + '''' 
		end									
						
						
	set @orderbyClause = ' ORDER BY
						empresas.nombre_empresa ASC,
						bitacora.sistema ASC,
						bitacora.funcion ASC'
						
	EXEC  (@selectClause + @fromClause + @whereClause + @orderbyClause)
GO


/**************************************************************************************************
 * Name          : reporteBitacoraPorFecha
 * Project       : Usuarios
 * Description   : reporte bitacora por Usuario                 
 * Table name    : bitacora
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteBitacoraPorFecha'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteBitacoraPorFecha
GO

CREATE PROCEDURE [dbo].reporteBitacoraPorFecha
	(@empresa as bigint,
	 @fechaDe as datetime,
	 @fechaA as datetime)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)
    
	set @selectClause = ' SELECT
						isnull(CONVERT(VARCHAR(10),bitacora.fecha,103),'''') as fecha,
						isnull(bitacora.hora,'''') as hora,
						isnull(bitacora.funcion,'''') as funcion,
						isnull(funciones.descripcion,'''') as nombrefuncion,
						isnull(bitacora.opcion,'''') as opcion,
						isnull(bitacora.opcion2,'''') as opcion2,
						isnull(bitacora.opcion3,'''') as opcion3,
						isnull(bitacora.usuario,'''') as usuario,
						isnull(bitacora.codigo,'''') as codigo,					
						isnull(sistema.nombre,'''') as sistema,
						bitacora.empresa'
						
	set @FromClause =	' FROM bitacora bitacora 
						LEFT JOIN sistema ON bitacora.sistema = sistema.sistema
						left join funciones on funciones.funcion=bitacora.funcion and funciones.sistema=bitacora.sistema '
						
	set @WhereClause =	' WHERE
						bitacora.fecha >= ''' +  CONVERT(VARCHAR(10),@fechade,112) + ''' AND
						bitacora.fecha <= ''' +  CONVERT(VARCHAR(10),@fechaA,112)  + ''''
						
	if  @empresa <> 0 
		begin
			set @WhereClause = @whereclause + ' AND bitacora.empresa='  + convert(varchar(4),@empresa)
		end
						
	set @OrderByClause =' ORDER BY
						bitacora.fecha desc,
						bitacora.hora desc'		
		
	exec (@selectClause + @fromClause + @whereClause + @orderbyClause)

GO



/**************************************************************************************************
 * Name          : reporteFuncionesOpcionesPorSistema
 * Project       : Usuarios
 * Description   : reporte usuario Expiracion                 
 * Table name    : usuarios
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 29 de sept de 2011
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteFuncionesOpcionesPorSistema'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteFuncionesOpcionesPorSistema
GO

CREATE PROCEDURE [dbo].reporteFuncionesOpcionesPorSistema
( @sistema as varchar(2))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
            
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    
	set @selectClause = ' SELECT	sistema.sistema, 
						sistema.nombre,
						funciones.funcion,
						funciones.descripcion as nombreFuncion,
						opciones.opcion,
						opciones.descripcion as nombreOpcion'					
	set @FROMClause = ' FROM funciones, opciones, sistema'
	set @WHEREClause = ' where sistema.sistema=funciones.sistema
						and sistema.sistema=opciones.sistema						
						and funciones.funcion=opciones.funcion'
						
	if  @sistema <>''
		begin
			set @WhereClause = @whereclause + ' and sistema.sistema='''  + @sistema + ''''
		end
						
	EXEC (@selectClause + @fromClause + @whereClause)

GO


/**************************************************************************************************
 * Name          : nuevoPerfil
 * Project       : Usuarios
 * Description   : nuevo perfil              
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 5 de enero 2012
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'nuevoPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.nuevoPerfil
GO

CREATE PROCEDURE dbo.nuevoPerfil
	(  @descripcion as varchar(30),
	   @sistema as varchar(2),
	   @actualizar as char(1),
	   @sueldo as char(1))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
            
	INSERT INTO perfiles
           (descripcion
           ,sistema
           ,empresas
           ,nomina
           ,actualizar
           ,sueldo)
     VALUES
           (@descripcion
           ,@sistema
           ,'{}'
           ,'{}'
           ,@actualizar
           ,@sueldo)
GO


/**************************************************************************************************
 * Name          : actualizaPerfil
 * Project       : Usuarios
 * Description   : nuevo perfil              
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 5 de enero 2012
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'actualizaPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.actualizaPerfil
GO

CREATE PROCEDURE dbo.actualizaPerfil
	(   @idPerfil as bigint,
		@descripcion as varchar(30),
		@sistema as varchar(2),
		@empresas as varchar(300),
		@nomina as varchar(15),
		@actualizar as char(1),
		@sueldo as char(1))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    
    UPDATE dbo.perfiles
	SET [descripcion] = @descripcion
       ,[sistema] = @sistema
       ,[empresas] = @empresas
       ,[nomina] = @nomina
       ,[actualizar] = @actualizar
       ,[sueldo] = @sueldo
	WHERE idperfil=@idPerfil
            
GO

 
/**************************************************************************************************
 * Name          : actualizaFEchaAlta
 * Project       : Usuarios
 * Description   : nuevo perfil              
 * Table name    : perfiles
 * Copyright     : 
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : jueves, 5 de julio 2015
 **************************************************************************************************/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'actualizaFEchaAlta'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.actualizaFEchaAlta
GO
CREATE PROCEDURE [dbo].[actualizaFEchaAlta]

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    declare @dias as bigint
    
    select @dias=Dias_vigencia
    from Ctrl_usuarios
    
	update usuarios set fechaAlta= (expiracion-@dias)
	where fechaAlta ='19000101'
           
GO

exec actualizaFEchaAlta
go


